;Merkmeister - newcode - 30.07.2010 - SpionAtom

	Const xr = 512, yr = 512, fps = 60
	Global xr2 = xr / 2, yr2 = yr / 2, fps_timer = CreateTimer(fps)
	Graphics3D xr, yr, 0, 2
	Graphics3D xr, yr, 0, 3
	AppTitle "Merk Meister - fr 2 Spieler"
	SeedRnd MilliSecs()
	
	Const maxpics = 20, picsize = 64, border = 30
	Global maxpics1 = maxpics - 1
	
	;Dinge, die fr alle Spieler gelten
	Global piccount, maxrelpicked
	
	;Spieler Individuelles
	Type Player
		Field abx, aby, picked, abspicked, relpicked, taken, takenval, ani#, done, fadeout#
		Field key_up, key_down, key_left, key_right
		Field picMyKeys, picMKx, picMKy
		Field dat[maxpics]
		Field sprites[maxpics]
	End Type
	
	Dim S.Player(1)
	S(0) = New Player: S(0)\key_up = 200: S(0)\key_down = 208: S(0)\key_left = 203: S(0)\key_right = 205
	S(0)\aby = yr * 0.28
	
	S(1) = New Player: S(1)\key_up = 17: S(1)\key_down = 31: S(1)\key_left = 30: S(1)\key_right = 32
	S(1)\aby = yr2 + yr * 0.35
	
	;3D-Setup
	cam = CreateCamera()
	CameraRange cam, 1, xr2 + 1000
	
	
	;Grafiken laden
	AutoMidHandle True
	titel = LoadSprite("titel.png", 261)
	pics = LoadAnimImage("pics64.png", picsize, picsize, 0, maxpics)
	Global picframe = LoadImage("frame64.png")
	
	For i = 0 To maxpics1
		SaveImage pics, i+"tmppic.bmp", i
		S(0)\sprites[i] = LoadSprite(i+"tmppic.bmp", 261)
		S(1)\sprites[i] = LoadSprite(i+"tmppic.bmp", 261)
		DeleteFile i+"tmppic.bmp"	
	Next
	
	S(0)\picMyKeys = LoadImage("pfeilsteuerung.png"): S(0)\picMKx = ImageWidth(S(0)\picMyKeys) / 2 + 10: S(0)\picMKy = ImageHeight(S(0)\picMyKeys) / 2 + 10
	S(1)\picMyKeys = LoadImage("wsadsteuerung.png"): S(1)\picMKx = xr - ImageWidth(S(1)\picMyKeys) / 2 - 10: S(1)\picMKy = yr - ImageHeight(S(0)\picMyKeys) / 2 - 10
	scrollpfeile = LoadAnimImage("scrollpfeile.png", 16, 16, 0, 2)
	
	SetFont LoadFont("Berlin Sans FB", 25)
	
	Global bg = CreateImage(xr, yr)
	SetBuffer ImageBuffer(bg)
	Color 50, 150, 50
	Rect 1, 1, xr - 2, yr2 - 2, 0
	Rect 1, yr2 + 1, xr - 2, yr2 - 2, 0
	HandleImage bg, 0, 0
	
	;sonstiges
	Global phase_timer = 0
	Global textmod = 0
	Global showScroller = 0
	Global countdown = 0
	Global alldone = 0
	
	
	
	;--- Startbildschirm ---
	
	firstStart = 0 ;Gibt an, ob das Spiel schon einmal gestartet wurde, falls ja, wird die Hilfe bersprungen
	
	Repeat
	
		SetBuffer BackBuffer()
		titelfaktor# = 1
		FlushKeys()
		sz = 0
		Color 0, 200, 0
		

		For p = 0 To 1
			For i = 0 To maxpics1
				HideEntity S(p)\sprites[i]
			Next
		Next

		
		For i = 4 To maxpics1 ;Mischen
			z = Rand(4, maxpics1)
			For p = 0 To 1
				tmp = S(p)\sprites[i]
				S(p)\sprites[i] = S(p)\sprites[z]
				S(p)\sprites[z] = tmp
			Next
		Next
		
		restart = 0
		
		Repeat

			ScaleSprite titel, (256 * titelfaktor / 100.) / 2, (256 * titelfaktor / 100.) / 2
			If sz = 0 Then
				titelfaktor = titelfaktor * 1.05
				If titelfaktor > 99 Then sz = MilliSecs(): titelfaktor = 100
			Else
				titelfaktor = 100 + Sin((MilliSecs() - sz) / 5 ) * 20
			End If
	
			Cls
			PositionEntity titel, 0, yr / 4, xr2
			UpdateWorld
			RenderWorld
		
			If sz > 0 Then
				Text 0, 0, "Ein Spiel von SpionAtom  -  Juli 2o1o"
				Text 30, 300, "Stopfe dein Hirn voll und besiege deinen Gegner!"
				Text 30, 320, Chr(34) + "Ich packe meinen Koffer" + Chr(34) + " als erfrischende visuelle"
				Text 30, 340, "Variante. Zeige, dass du mehr Hirn besitzt, als"
				Text 30, 360, "dein Gegner, indem du dein Gedchtnis und dein"
				Text 30, 380, "Geschick im Sortieren unter Beweis stellst."
				
				Text 30, yr - 30 - StringHeight("|"), "[enter] Start                                          [esc] Ende"
			End If
		
			Flip(0)
			WaitTimer fps_timer	
			
			If KeyHit(28) Or KeyHit(156) Then
				HideEntity titel
				doGame(firstStart)
				firstStart = 1
				FlushKeys()
				ShowEntity titel
				restart = 1
			End If
	
	
		Until KeyDown(1) Or restart = 1
	
	
	
	Until KeyDown(1)
	End
	
	
Function doGame(skipKeytutorial)


	If skipKeytutorial Then phase = 2 Else phase = 0
	showScroller = 0
	
	;Phase 0 - Tutorial vorbereiten
	;Phase 1 - Tutorial spielen
	;Phase 2 - Ersten 5 Symbole vorgeben
	
	;Phase 3 - Spielen
	;Phase 4 - weitere 2 Symbole dazu
	;Phase 3 - Spielen...
	
	
	
	
	
	Repeat
	
		S(0)\picked = S(0)\abspicked + S(0)\relpicked
		S(1)\picked = S(1)\abspicked + S(1)\relpicked
	
	
		Cls
		drawGame(phase)
		
		Color 255, 255, 255
		
		
		;Text 10, 10, "abspicked: " + S(0)\abspicked + ", relpicked: " + S(0)\relpicked + ", picked: " + S(0)\picked + ", dat: " + S(0)\dat[S(0)\picked]
		;Text 10, 25, "fadeout: " + S(0)\fadeout
		;For i = 0 To maxrelpicked
		;		xx = S(0)\abx + i * (picsize + border / 2)
		;		yy = S(0)\aby
		;		Text xx, yy, S(0)\dat[S(0)\abspicked + i]
		;Next
		

		Flip(0)
	
		
		
	
		;Steuerung
		For p = 0 To 1
			If S(p)\done = 0 Then
			
				If KeyHit(S(p)\key_up) And S(p)\taken = -1 Then
					S(p)\taken = S(p)\picked
					S(p)\takenval = S(p)\dat[S(p)\picked]
					S(p)\dat[S(p)\picked] = -1
				End If
			
				If KeyHit(S(p)\key_down) And S(p)\taken <> -1 Then
					S(p)\dat[S(p)\picked] = S(p)\takenval: S(p)\taken = -1
				End If
				
				If KeyHit(S(p)\key_left) Then
					If S(p)\relpicked > 0 Then
						S(p)\relpicked = S(p)\relpicked - 1
						If S(p)\taken <> -1 Then S(p)\dat[S(p)\picked] = S(p)\dat[S(p)\picked - 1]: S(p)\dat[S(p)\picked - 1] = -1: S(p)\taken = S(p)\taken - 1: ani = -1 * (picsize + 2 * border)
					Else If S(p)\abspicked > 0 Then
						If S(p)\taken <> -1 Then S(p)\dat[S(p)\picked] = S(p)\dat[S(p)\picked - 1]: S(p)\dat[S(p)\picked - 1] = -1: ani = -1 * (picsize + 2 * border)
						S(p)\abspicked = S(p)\abspicked - 1
					End If
				End If
				
				If KeyHit(S(p)\key_right) Then
					If S(p)\relpicked < maxrelpicked Then
						S(p)\relpicked = S(p)\relpicked + 1
						If S(p)\taken <> -1 Then S(p)\dat[S(p)\picked] = S(p)\dat[S(p)\picked + 1]: S(p)\dat[S(p)\picked + 1] = -1:S(p)\taken = S(p)\taken + 1: ani = +1 * (picsize + 2 * border): DebugLog S(0)\dat[S(0)\picked + 1]
					Else If S(p)\abspicked + S(p)\relpicked < piccount - 1 Then
						If S(p)\taken <> -1 Then S(p)\dat[S(p)\picked] = S(p)\dat[S(p)\picked + 1]: S(p)\dat[S(p)\picked + 1] = -1:ani = +1 * (picsize + 2 * border)
						S(p)\abspicked = S(p)\abspicked + 1
					End If
				End If
				
				
				
				
			
			End If
		Next
		
	
	
		Select phase
			Case 0 ;Tutorial vorbereiten
				piccount = 4
				maxrelpicked = 3
				countdown = 0
				alldone = 0
				
				For p = 0 To 1
					For i = 0 To piccount - 1
						S(p)\dat[i] = piccount - i - 1
						
					Next
					
					S(p)\abx = (xr - (picsize + border / 2) * maxrelpicked) / 2
					S(p)\done = 0
					S(p)\taken = -1
					S(p)\fadeout = 0
					S(p)\abspicked = 0
					S(p)\relpicked = 0
				Next
				
				showScroller = 1
				phase = 1
				
			Case 1 ;Tutorial spielen
				allfadeout = 0
				For p = 0 To 1
				
					If S(p)\taken = -1 Then S(p)\done = 1
					For i = 0 To piccount - 2
						If S(p)\dat[i] > S(p)\dat[i + 1] Then S(p)\done = 0
					Next
					If S(p)\done = 1 And S(p)\fadeout = 0 Then S(p)\fadeout = 0.01
					
					If S(p)\fadeout > 0 Then S(p)\fadeout = S(p)\fadeout + 0.01: If S(p)\fadeout > 1 Then S(p)\fadeout = 1: allfadeout = allfadeout + 1
				Next
				If allfadeout = 2 Then ;2 Spieler
					phase = 2
				End If
				
			Case 2 ;Ersten 5 vorbereiten
				piccount = 5
				maxrelpicked = 4
				showScroller = 0
				countdown = 0
				alldone = 0
				
				For p = 0 To 1
					For i = 0 To piccount - 1
						S(p)\dat[i] = 4 + i
					Next
					
					;Mischen
					gemischt = 0
					While gemischt = 0
						For i = 0 To piccount - 1
							If p = 0 Then
								tmp = S(p)\dat[i]
								z = Rand(0, piccount - 1)
								S(p)\dat[i] = S(p)\dat[z]
								S(p)\dat[z] = tmp
							Else
								S(p)\dat[i] = S(0)\dat[i]
							End If
						Next
						gemischt = 0
						For i = 0 To piccount - 2
							If S(p)\dat[i] > S(p)\dat[i + 1] Then gemischt = 1
						Next
					Wend
					
					S(p)\abx = (xr - (picsize + border / 2) * maxrelpicked) / 2
					S(p)\done = 0
					S(p)\taken = -1
					S(p)\fadeout = 0
					S(p)\abspicked = 0
					S(p)\relpicked = 0
					
				Next
				If phase_timer = 0 Then phase_timer = MilliSecs() + 4000
				If phase_timer < MilliSecs() Then
					For i = 0 To piccount - 1
						blendInPic 4 + i
					Next
					textmod = Rand(0, 3)
					phase_timer = 0
					phase = 3
					showScroller = 1
				End If
				
			Case 3 ;Rundenberprfung
				
				If alldone < 2 Then
					alldone = 0
					For p = 0 To 1
					
						If S(p)\taken = -1 Then S(p)\done = 1
						For i = 0 To piccount - 2
							If S(p)\dat[i] > S(p)\dat[i + 1] Then S(p)\done = 0
						Next
						If S(p)\done = 1 And S(p)\fadeout = 0 Then
							S(p)\fadeout = 0.01
							;andere Spieler auf Countdown setzen
							If countdown = 0 Then countdown = MilliSecs() + 3000 + piccount * 500
						End If
	
						alldone = alldone + S(p)\done
					Next
					If alldone = 2 Then ;2 Spieler
						textmod = Rand(0, 3)
					End If
				End If
				
				If countdown > 0 And countdown < MilliSecs() Then
					If S(0)\done Then SpielerGewinnt(1): Return
					If S(1)\done Then SpielerGewinnt(2): Return
				End If
				
				allfadeout = 0
				For p = 0 To 1
					If S(p)\fadeout > 0 Then S(p)\fadeout = S(p)\fadeout + 0.01: If S(p)\fadeout > 1 Then S(p)\fadeout = 1: allfadeout = allfadeout + 1
				Next
				If allfadeout = 2 Then ;2 Spieler
					phase = 4
					piccount = piccount + 2: If piccount > maxpics Then SpielerGewinnt(0): Return
					textmod = Rand(0, 3)
				End If
			
			Case 4 ;Nchsten 2 Symbole vorbereiten
				
				maxrelpicked = 4
				showScroller = 0
				countdown = 0
				alldone = 0
				
				For p = 0 To 1
					For i = 0 To piccount - 1
						S(p)\dat[i] = 4 + i
					Next
					
					;Mischen
					gemischt = 0
					While gemischt = 0
						For i = 0 To piccount - 1
							If p = 0 Then
								tmp = S(p)\dat[i]
								z = Rand(0, piccount - 1)
								S(p)\dat[i] = S(p)\dat[z]
								S(p)\dat[z] = tmp
							Else
								S(p)\dat[i] = S(0)\dat[i]
							End If
						Next
						gemischt = 0
						For i = 0 To piccount - 2
							If S(p)\dat[i] > S(p)\dat[i + 1] Then gemischt = 1
						Next
					Wend
					
					S(p)\abx = (xr - (picsize + border / 2) * maxrelpicked) / 2
					S(p)\done = 0
					S(p)\taken = -1
					S(p)\fadeout = 0
					S(p)\abspicked = 0
					S(p)\relpicked = 0
					
				Next
				If phase_timer = 0 Then phase_timer = MilliSecs() + 4000
				If phase_timer < MilliSecs() Then
					For i = piccount - 2 To piccount - 1
						blendInPic 4 + i
					Next
					textmod = Rand(0, 3)
					phase_timer = 0
					phase = 3
					showScroller = 1
				End If
				
				
		End Select
		
		WaitTimer fps_timer
	
	Until KeyDown(1)
	



End Function



Function drawGame(phase)
		
		;3d Teil
		For p = 0 To 1
		
			For i = 0 To maxpics1
				HideEntity S(p)\sprites[i]
				EntityAlpha S(p)\sprites[i], 1 - S(p)\fadeout
			Next
		
			
			If showScroller = 1 Then
			
				For i = 0 To maxrelpicked
					If S(p)\relpicked = i And S(p)\done = 0 Then f# = 1.4 + Sin(MilliSecs() / 5) * 0.2 Else f# = 1
					xx = S(p)\abx + i * (picsize + border / 2)
					yy = S(p)\aby
					If S(p)\dat[S(p)\abspicked + i] <> -1 Then
						ShowEntity S(p)\sprites[S(p)\dat[S(p)\abspicked + i]]
						
						ScaleSprite S(p)\sprites[S(p)\dat[S(p)\abspicked + i]], (picsize / 2) * f, (picsize / 2) * f
						PositionEntity S(p)\sprites[S(p)\dat[S(p)\abspicked + i]], xx - xr2, yr2 - yy, xr2
					End If
				Next
				
				If S(p)\taken <> -1 Then
						xx = S(p)\abx + S(p)\relpicked * (picsize + border / 2)
						yy = S(p)\aby - picsize
						ShowEntity S(p)\sprites[S(p)\takenval]
						ScaleSprite S(p)\sprites[S(p)\takenval], (picsize / 2) * 1.4, (picsize / 2) * 1.4
						PositionEntity S(p)\sprites[S(p)\takenval], xx - xr2, yr2 - yy, xr2
				End If
				
				If S(p)\abspicked > 0 Then
					f# = 0.5
					xx = S(p)\abx - picsize 
					yy = S(p)\aby
					ShowEntity S(p)\sprites[S(p)\dat[S(p)\abspicked - 1]]
					ScaleSprite S(p)\sprites[S(p)\dat[S(p)\abspicked -1]], (picsize / 2) * f, (picsize / 2) * f
					PositionEntity S(p)\sprites[S(p)\dat[S(p)\abspicked -1]], xx - xr2, yr2 - yy, xr2
				End If
	
				If S(p)\abspicked < piccount - maxrelpicked - 1 Then
					f# = 0.5
					xx = S(p)\abx + maxrelpicked * (picsize + border / 2) + picsize
					yy = S(p)\aby
					ShowEntity S(p)\sprites[S(p)\dat[S(p)\abspicked + maxrelpicked + 1]]
					ScaleSprite S(p)\sprites[S(p)\dat[S(p)\abspicked + maxrelpicked + 1]], (picsize / 2) * f, (picsize / 2) * f
					PositionEntity S(p)\sprites[S(p)\dat[S(p)\abspicked + maxrelpicked + 1]], xx - xr2, yr2 - yy, xr2
				End If
			
			End If

		Next
		
		
		
		UpdateWorld
		RenderWorld

		
		;2d Teil
		DrawImage bg, 0, 0
		
		Select phase
			Case 1
				For p = 0 To 1
					DrawImage S(p)\picMyKeys, S(p)\picMKx, S(p)\picMKy
				Next
				CenterBox(1)
			
			Case 2
				CenterBox(2)
			
			Case 3
				If countdown = 0 Then
					CenterBox(3, textmod)
				Else If alldone = 2 Then
					CenterBox(5, textmod)
				Else If countdown > 0
					CenterBox(4, -1)
				End If
			
			Case 4
				CenterBox(6, textmod)
				
		
		End Select
		
		
		
End Function

Function SpielerGewinnt(n)

	FlushKeys()
	Cls
	DrawImage bg, 0, 0
	
	If n = 1 Then
		Color 255, 255, 0
		Text 10, 10, "Spieler 1 gewinnt"
		Color 155, 55, 0
		Text 10, yr / 2 + 25, "Spieler 2 verliert"
	Else If n = 2 Then
		Color 155, 55, 0
		Text 10, 10, "Spieler 1 verliert"
		Color 255, 255, 0
		Text 10, yr / 2 + 25, "Spieler 2 gewinnt"
	Else
		Color 255, 255, 0
		Text 10, 10, "Unentschieden"
		Color 255, 255, 0
		Text 10, 10, "Unentschieden"
	
	End If
	
	Flip()
	WaitKey

End Function

Function blendInPic (n)

	
For i = 0 To maxpics1
	HideEntity S(0)\sprites[i]
	HideEntity S(1)\sprites[i]
Next
	
	
	xx = xr2
	yy = yr2
	ShowEntity S(0)\sprites[n]
	ScaleSprite S(0)\sprites[n], xr / 2, yr / 2
	PositionEntity S(0)\sprites[n], xx - xr / 2, yr / 2 - yy, xr / 2


For i = 0 To 100 Step 2
	Cls
	EntityAlpha S(0)\sprites[n], i / 100.
	UpdateWorld()
	RenderWorld()
	Flip(0)
	WaitTimer fps_timer
Next
For i = 100 To 1 Step -2
	Cls
	EntityAlpha S(0)\sprites[n], i / 100.
	UpdateWorld()
	RenderWorld()
	Flip(0)
	WaitTimer fps_timer
Next

HideEntity S(0)\sprites[n]
EntityAlpha S(0)\sprites[n], 1

End Function

Function CenterBox(n, z = 0)


	Select n
		Case 1
			Restore box1
		Case 2
			Restore box2
		Case 3
			Select z
				Case 0
					Restore box3_1
				Case 1
					Restore box3_2
				Case 2
					Restore box3_3
				Case 3
					Restore box3_4
			End Select
				
		Case 4
			Restore box3_1b
					
		Case 5
			Select z
				Case 0
					Restore box3_1c
				Case 1
					Restore box3_2c
				Case 2
					Restore box3_3c
				Case 3
					Restore box3_4c
			End Select

		Case 6
			Select z
				Case 0
					Restore box4_1
				Case 1
					Restore box4_2
				Case 2
					Restore box4_3
				Case 3
					Restore box4_4
			End Select	
	End Select
	
	
	h = StringHeight("|") + 0
	Read lines
	
	Color 0, 0, 0: Rect 15, yr2 - lines * h * .5, xr - 30, lines * h, 1
	Color 0, 200, 0: Rect 15, yr2 - lines * h * .5, xr - 30, lines * h, 0
	
	
	For i = 0 To lines - 1
		Read txt$
		If z = -1 Then txt$ = txt$ + " " + (countdown - MilliSecs()) / 1000.0
		Text 16, yr2 - lines * h * .5 + i * h, txt
	Next


End Function

.box1
Data 4
Data "Ziel des Spiels ist es, die Symbole in der Reihenfolge"
Data "anzuordnen, in der sie Euch gezeigt werden. Mittels"
Data "Eurer Tasten knnt ihr die Symbole in Eurer Leiste"
Data "verschieben. Kann es LOS!gehen ?"

.box2
Data 2
Data "Aufgepasst, hier kommen Euren ersten fnf"
Data "Symbole. Merkt sie Euch gut!"

.box3_1
Data 1, "Schnell, sortiere die Symbole so schnell du kannst!"

.box3_2
Data 1, "Beei Dich mit dem Sortieren der Symbole!"

.box3_3
Data 1, "Ordne die Symbole so schnell du kannst!"

.box3_4
Data 1, "Jetzt bist du gefragt, sortiere!"

.box3_1b
Data 1, "Achtung, Deine Zeit luft ab!"

.box3_1c
Data 1, "Super, alles geschafft!"

.box3_2c
Data 1, "Klasse gemacht!"

.box3_3c
Data 1, "Sehr schn!"

.box3_4c
Data 1, "Prima!"

.box4_1
Data 1, "Zwei weitere Symbole kommen hinzu."

.box4_2
Data 1, "Es geht weiter mit zwei weiteren Symbolen."

.box4_3
Data 1, "Eure Symbolleiste wird nun aufgestockt."

.box4_4
Data 1, "Es kommen die nchsten zwei Symbole."
;~IDEal Editor Parameters:
;~C#Blitz3D