AppTitle "Run!"


Graphics 800, 600,16,1
SetBuffer BackBuffer()
HidePointer

Include "islands01.bb"


Global jet_x#=start_x
Global jet_y#=start_y
Global jet_degree%=start_winkel

Global jet_speed# = start_speed
Const jet_agility# = 2

Global gun1_x# = 400
Global gun1_y# = 600
Global gun1_timer = MilliSecs()

Global gun2_x# = 800
Global gun2_y# = 300
Global gun2_timer = MilliSecs()

Const firedelay =800
Const bullet_speed = 6

Type shot
	Field x#
	Field y#
	Field w#
End Type
Local shots.shot

Global collision = 1
Global cp_count = anzahl_cps

maintimer=CreateTimer(60)

TFormFilter 0

Dim jet%(35)
For i=0 To 35
	jet(i) = LoadImage("jet.bmp")
	MidHandle jet(i)
	MaskImage jet(i), 255,0,255
	RotateImage jet(i), i*10
	
Next

island_img = LoadImage("island.bmp")
MidHandle island_img
clouds = LoadImage("clouds.bmp")
explosion = LoadImage("explosion.bmp")
MidHandle explosion
MaskImage explosion, 255, 0, 255
;gun = LoadImage("gun.bmp",2)
;rocket = LoadImage("rocket.bmp",2)

While Not KeyHit(1)
	Cls
	
	;Spielneustart
	If KeyDown(57) And MouseDown(1) And collision And MouseX() >700 And MouseY() >500 Then
		collision = 0
		jet_x = start_x
		jet_y = start_y
		jet_degree = start_winkel
		jet_speed = start_speed
		For i = 0 To anzahl_cps
			cps(i,2) = 0
		Next
	EndIf
	
	;Hintergrundgrafik
	TileBlock clouds
	;Inseln malen
	Color 0,0,0
	For i=0 To anzahl_inseln
		DrawImage island_img,islands(i,0),islands(i,1)
		If show_island_numbers Then
			Text islands(i,0),islands(i,1),Str(i),1,1
		EndIf
	Next
	
	;checkpoints malen
	For i = 0 To anzahl_cps
		If Not cps(i, 2) Then
			Color 255,0,0
			Oval cps(i,0),cps(i,1), 20, 20, 1
		Else
			Color 0, 255, 0
			Oval cps(i,0),cps(i,1), 20, 20, 1
		EndIf	
	Next
	
	;checkpoints chekcen
	For i = 0 To anzahl_cps
	If dist(jet_x,jet_y,cps(i,0), cps(i,1)) < 18 Then
		cps(i,2) = 1
	EndIf
	Next
	;winnertext
	Color 0,0,0
	If collision Then
		Text 200, 200, "Maus gewinnt"
		Rect 700, 500, 100, 100, 1
		Color 255,255,255
		Text 700, 500, "Zum Neustart"
		Text 700, 515, "gleichzeitig"
		Text 700, 530, "hier Klicken"
		Text 700, 545, "und LEER"
		Text 700, 560, "drcken."
	EndIf
	
	;Jet bewegen........
	If KeyDown(200) Then ;hoch
		If jet_speed < 3.9 Then jet_speed = jet_speed + .1
	ElseIf KeyDown(208) Then ;runter
		If jet_speed > 1 Then jet_speed = jet_speed - .1
	EndIf
	If KeyDown(203) Then ;links
		jet_degree = jet_degree -1*jet_agility
		If jet_degree < 0 Then
			jet_degree = jet_degree + 360
		EndIf
	ElseIf	KeyDown(205) ;rechts
		jet_degree = jet_degree +1*jet_agility
		If jet_degree > 359 Then
			jet_degree = jet_degree - 360
		EndIf
	EndIf
	If Not collision Then
		jet_x = jet_x + Cos(jet_degree)*jet_speed
		jet_y = jet_y + Sin(jet_degree)*jet_speed
		If jet_x < 10 Then jet_x = 10
		If jet_x > 790 Then jet_x = 790
		If jet_y < 10 Then jet_y = 10
		If jet_y > 590 Then jet_y = 590
	EndIf
	
	;Jet malen..............................................;..
	If Not collision Then
		DrawImage jet(Floor(jet_degree/10)),jet_x,jet_y	
	Else
		DrawImage explosion,jet_x,jet_y
	EndIf
	
	;guns malen
	Color 255, 0 ,0
	Oval gun1_x-10, gun1_y-10, 20, 20, 1
	Oval gun2_x-10, gun2_y-10, 20, 20, 1
	Color 0, 255, 0
	Line gun1_x, gun1_y, MouseX(), MouseY()
	Line gun2_x, gun2_y, MouseX(), MouseY()
	
	;gun1 ladeleiste
	Color 0,0,0
	Rect gun1_x+19, gun1_y-13, 56, 12, 0
	Color 255,255,255
	Rect gun1_x+20, gun1_y-12, 54, 10, 1
	Color 0,0,0
	If gun1_timer >= MilliSecs() Then
		filled = ( 1000 - (gun1_timer - MilliSecs() ) ) / 20
		Color 0,0,0
	Else
		filled = 50
		Color 0,255,0
	EndIf
	Rect gun1_x+22, gun1_y-10, filled, 6, 1
	
	;gun2 ladeleiste
	Color 0,0,0
	Rect gun2_x-13, gun2_y+19, 12, 56, 0
	Color 255,255,255
	Rect gun2_x-12, gun2_y+20, 10, 54, 1
	Color 0,0,0
	If gun2_timer >= MilliSecs() Then
		filled = 50 - ( 1000 - (gun2_timer - MilliSecs() ) ) / 20
		filled2 = ( 1000 - (gun2_timer - MilliSecs() ) ) / 20
		Color 0,0,0
	Else
		filled = 0
		filled2 = 50
		Color 0,255,0
	EndIf
	Rect gun2_x-10, gun2_y+22+filled, 6, filled2, 1

	
	;crosshair malen
	Color 0,0,0
	Oval MouseX()-10, MouseY()-10, 20, 20, 0
	Line MouseX()-20, MouseY(), MouseX()+20, MouseY()
	Line MouseX(), MouseY()-20, MouseX(), MouseY()+20
	;Text MouseX()-40, MouseY()-40,Str(winkel(gun2_x, gun2_y, MouseX(), MouseY())-1) 
	;Text MouseX()-40, MouseY()-50,Str(ACos(winkel(gun1_x, gun1_y, MouseX(), MouseY())) )
	
	
	;guns abfeuern
	If MouseDown(1) And MilliSecs() > gun1_timer Then
		gun1_timer = MilliSecs()+firedelay
		shots = New shot
		shots\x = gun1_x
		shots\y = gun1_y
		shots\w = winkel(gun1_x, gun1_y, MouseX(), MouseY())
		
		
	EndIf
	If MouseDown(2) And MilliSecs() > gun2_timer Then
		gun2_timer = MilliSecs()+firedelay
		shots = New shot
		shots\x = gun2_x
		shots\y = gun2_y
		If MouseY()>gun2_y Then
			shots\w = -winkel(gun2_x, gun2_y, MouseX(), MouseY())
		Else
			shots\w = winkel(gun2_x, gun2_y, MouseX(), MouseY())
		EndIf

	EndIf
	
	;shots bewegen
	For shots = Each shot
		shots\x = shots\x + Cos(shots\w)*bullet_speed
		shots\y = shots\y - Sin(shots\w)*bullet_speed
	Next
	;shots malen
	Color 255, 0, 255
	For shots = Each shot
		Oval shots\x-4,shots\y-4,8,8,1
	Next
	;flugzeug kollision?
	For shots = Each shot
		If dist(jet_x, jet_y, shots\x, shots\y) <16 Then
		collision = 1
		shots\x=-1
		shots\y=-1
		EndIf
	Next
	;shots lschen
	For shots = Each shot
		If shots\x < 0 Or shots\y < 0 Then	;shots auerhalb des bildschirms
			Delete shots.shot
		Else
			For i=0 To anzahl_inseln		;shots treffen inseln
				If Abs(shots\x - islands(i,0))<15 And Abs(shots\y-islands(i,1))<15
					shots\x=-1
					shots\y=-1
				EndIf
			Next
		EndIf
	Next
	
	;Kollision mit Insel
	For i = 0 To anzahl_inseln
		If dist(islands(i,0),islands(i,1),jet_x,jet_y) < 30
			collision = 1
			jet_speed = 0
		EndIf
	Next
	
	;Winkel anzeige oben links
	;Color 0,0,0
	;Text 5,5,Str(jet_degree)
	;Text 5, 15, Str(Floor(jet_degree/10))
	;Text 5, 25, Str(jet_speed)
	
	
	Flip 0
	WaitTimer maintimer
Wend
End

Function dist(a1#,a2#,b1#,b2#)
	Return Sqr(Abs(a1-b1)^2+Abs(a2-b2)^2)
End Function

Function winkel#(a1#,a2#,b1#,b2#)
	Return ACos((b1-a1)/(Sqr((b1-a1)^2+(b2-a2)^2)))
End Function









