'Graphics 1024,768,16,60,GRAPHICS_BACKBUFFER
Graphics 1024,768
SeedRnd MilliSecs()

maxLeine# = 200
fps# = 50

both = LoadAnimImage("data/hund_mensch.bmp",48,64,0,13)
animTH = 0
animTM = 0
hAnim = 0
mAnim = 0

strassen = LoadAnimImage("data/strassen.bmp",32,32,0,6)
zeug = LoadAnimImage("data/zeug.bmp",48,48,0,14)

Global musics:TSound[1]
musics[0] = LoadSound("data/mus1.ogg",SOUND_LOOP)
If( musics[0] = Null ) DebugStop()

Global lvlH,sy,hx,hy,mx,my,strasse,again,dogPlayer,firstTime,level,channel:TChannel
Global punkte1,punkte2,punkte
level = 1
dogPlayer = 1
again = True
firstTime = True
strasse = 1

Function Menu()
	FlushKeys()
	If( channel <> Null ) StopChannel channel
	Repeat
		Cls
		
		If( firstTime )
			DrawText "Spieler "+dogPlayer+" ist der Hund.",10,30
			DrawText "Spieler "+(3-dogPlayer)+" ist der Mensch.",10,50
		ElseIf(again) 
			DrawText "Spieler "+dogPlayer+" ist erneut der Hund.",10,30
			DrawText "Spieler "+(3-dogPlayer)+" ist wiederum der Mensch.",10,50
			If( dogPlayer = 1 ) punkte1 :+ punkte Else punkte2 :+ punkte
		Else
			DrawText "Nun ist Spieler "+dogPlayer+" der Hund.",10,30
			DrawText "Diesmal ist Spieler "+(3-dogPlayer)+" der Mensch.",10,50	
			If( dogPlayer = 1 ) punkte2 :+ punkte Else punkte1 :+ punkte
		EndIf
		punkte = 0
		DrawText "Spieler 1 hat " + punkte1 + " Punkte",10,70
		DrawText "Spieler 2 hat " + punkte2 + " Punkte",10,90
		DrawText "Weiterspielen mit [ENTER]",10,110
		
		Delay 10
		Flip
		If( KeyHit(KEY_ESCAPE) ) End
		If( KeyHit(KEY_ENTER) ) Exit
	Forever
	channel = PlaySound(musics[0])
	SetChannelVolume(channel,0.5)
End Function

Function LoadLevel(num)
	ClearList(katzen)
	mx=500
	my=50
	hx=mx
	hy=my
	sy=0
	
	file = ReadFile("data/lvl"+num+".txt")
	lvlH = ReadLine(file).ToInt()
	strasse = ReadLine(file).ToInt()
	While( Not Eof(file) )
		art$ = ReadLine(file)
		k:Katze = New Katze
		k.x = ReadLine(file).ToInt()
		k.y = ReadLine(file).ToInt()
		k.farbe = Rand(1,3)
		k.vx = k.x
		k.vy = k.y
		If( art = "Katze" )
			k.art = 0
			dir$ = ReadLine(file)
			If( dir = "O" ) 
				k.dir=1
			ElseIf( dir = "S" )
				k.dir=2
			ElseIf( dir = "W" )
				k.dir=3
			Else
				k.dir=4
			EndIf
			k.dist = ReadLine(file).ToInt()
			k.hin = True
		ElseIf( art = "Pftze" )
			k.art = 1
		ElseIf( art = "Hydrant" )
			k.art = 2
		EndIf
		ListAddLast(katzen,k)
	Wend
End Function

Function GenerateLevel()
	ClearList(katzen)
	strasse = 1-strasse
	mx=500
	my=50
	hx=mx
	hy=my
	sy=0
	
	lvlH = Rand(2000,4000)
	oNum = Rand(40,60)
	For i = 1 To oNum
		k:Katze = New Katze
		k.art = Rand(0,2)
		If( k.art = 2 ) 'Hydrant
			'If( Rand(0,1) = 0 )
				'k.x = Rand(0,220)
			'Else
				k.x = Rand(0,1000)
			'EndIf
			k.y = Rand(500,lvlH-50)
		Else
			k.x = Rand(0,1000)
			k.y = Rand(500,lvlH-50)
		EndIf
		k.farbe = Rand(1,3)
		k.vx = k.x
		k.vy = k.y
		k.urx = k.x
		k.ury = k.y
		k.dir = Rand(1,4)
		k.dist = Rand(100,400)
		k.hin = True
		k.got = False
		ListAddLast(katzen,k)
	Next
End Function

Function ResetLevel()
	mx=500
	my=50
	hx=mx
	hy=my
	sy=0
	For cat:Katze = EachIn(katzen)
		cat.hin = True
		cat.x = cat.urx
		cat.y = cat.ury
		cat.vx = cat.x
		cat.vy = cat.y
		cat.got = False
	Next
End Function

Type Katze
	Field x,y
	Field vx,vy
	Field urx,ury
	Field dist,dir
	Field hin
	Field timer
	Field art
	Field farbe
	Field got
End Type

Global katzen:TList = New TList
'LoadLevel(1)
GenerateLevel()

Menu()

While Not KeyHit(KEY_ESCAPE)
	Cls
	
	t = MilliSecs()
	
	For ty = -1 To 24
		theY = ty*32 - (sy Mod 32)
		For tx = 0 To 31
			DrawImage strassen,tx*32,theY,strasse*3+0
		Next
		For tx = 5 To 31-5
			DrawImage strassen,tx*32,theY,strasse*3+1
		Next
		For tx = 8 To 31-8
			DrawImage strassen,tx*32,theY,strasse*3+2
		Next
	Next
	
	'Katzen.
	For k:Katze = EachIn(katzen)
		If( k.art = 0 )
			If( k.got ) Continue
			If( k.farbe = 1 ) colOff = 0
			If( k.farbe = 2 ) colOff = 6
			If( k.farbe = 3 ) colOff = 10
			If( k.dir = 1 Or k.dir = 2) cOff = 2 Else cOff = 0
			If( k.hin = False ) cOff = 2-cOff
			DrawImage zeug,k.x-24,k.y-24-sy,mAnim+cOff+colOff
			If( k.hin ) sg = 1 Else sg = -1
			Select(k.dir)
				Case 1 k.x :+ sg*1
				Case 2 k.y :+ sg*1
				Case 3 k.x :- sg*1
				Case 4 k.y :- sg*1
			End Select
			If( k.hin=True And (Abs(k.x-k.vx)>=k.dist Or Abs(k.y-k.vy)>=k.dist)) k.hin = False
			If( k.hin=False And (Abs(k.x-k.vx)<=0 And Abs(k.y-k.vy)<=0)) k.hin = True
		Else
			DrawImage zeug,k.x-24,k.y-24-sy,3+k.art
		EndIf
		If( ImagesCollide(zeug,k.x-24,k.y-24-sy,mAnim+cOff,both,hx-24,hy-48-sy,hAnim+offsAnim) )
			If( k.art = 0 )
				punkte :+ 1000
				'ListRemove(katzen,k)
				k.got = True
			ElseIf( k.art = 1 )
				punkte = 0
			Else
				punkte :+ 1
			EndIf
		EndIf
	Next

	If( t-animTH > 120 )
		hAnim = 1-hAnim
		animTH = t
	EndIf
	If( t-animTM > 240 )
		mAnim = 1-mAnim
		animTM = t
	EndIf
	
	DrawText "Punkte: "+punkte,10,70
	
	toX = 0
	toY = 0
	If( KeyDown(KEY_A) ) toX = -3
	If( KeyDown(KEY_D) ) toX = 3
	If( KeyDown(KEY_W) ) toY = -3
	If( KeyDown(KEY_S) ) toY = 3
	
	mx :+ toX
	my :+ toY
	If( mx-24 < 0 ) mx = 24
	If( my-48 < 0 ) my = 48
	If( mx+24>1024 ) mx = 1024-24
	If( my+12>lvlH ) 
		again=1-again
		If( Not again ) dogPlayer = 3-dogPlayer
		firstTime = False
		If( again ) 
			level :+ 1
			GenerateLevel()
		Else
			ResetLevel()
		EndIf
		Menu()
		'LoadLevel(level)
		'LoadLevel(1)
	EndIf
	
	If( my-sy > 768-400 ) sy = my-(768-400)
	If( my-sy < 350 ) sy = my-350
	
	
	If( toX = -3 ) 
		offsAnim = 10
	ElseIf( toX = 3 )
		offsAnim = 8
	ElseIf( toY = 3 )
		offsAnim = 4
	ElseIf( toY = -3 )
		offsAnim = 6
	Else	'Stehend
		offsAnim = 12
	EndIf
	If( offsAnim <> 12 )
		DrawImage both,mx-24,my-48-sy,mAnim+offsAnim
	Else
		DrawImage both,mx-24,my-48-sy,12
	EndIf
	If( hx < mx ) offsAnim = 0 Else offsAnim = 2
	DrawImage both,hx-24,hy-48-sy,hAnim+offsAnim
	DrawLine mx,my-12-sy,hx,hy-sy
	
	hx = MouseX()
	hy = MouseY()+sy
	dist# = Sqr( (hx-mx)^2 + (hy-my)^2 )
	If( dist > maxLeine )
		rel# = maxLeine/dist
		hx = mx+rel*(hx-mx)
		hy = my+rel*(hy-my)
		If( hy > my ) my :+ 1
		If( hy < my ) my :- 1
		If( hx > mx ) mx :+ 1
		If( hx < mx ) mx :- 1
	EndIf
	
	Delay 1.0/fps*1000-(MilliSecs()-t)
	DrawText MilliSecs()-t+" MS per Frame",10,10
	
	Flip
Wend
End