﻿SuperStrict

Rem
	Beitrag zum BCC #40, www.blitzforum.de
	
	Max:	14336 Byte
	Extern: 2MB 
	Hot Seat - Modus
	
	Bis: 3. August 2010, 23:59:59 
	
	Space Invaders - Clone
	
	Moment - ihr lest den Quellcode?! Habt ihr nichts zu tun?
	
EndRem

AppTitle = "Earth Invaders"
Graphics(512, 800, 0, 60)
AutoMidHandle(1)
Global gfx_w:Int = GraphicsWidth(), gfx_w2:Int = gfx_w / 2
Global gfx_h:Int = GraphicsHeight() , gfx_h2:Int = gfx_h / 2
SeedRnd MilliSecs()
Local Frametimer:TTimer = TTimer.Create(60)
'* Große Schrift lässt sich besser herunterscalieren als kleine herauf.
SetImageFont(LoadImageFont(getenv_("windir") + "\fonts\" + "Arial.ttf", 24))

Global mx:Int, my:Int, mh1:Int, mh2:Int, md1:Int, md2:Int, ms:Float
Const GS_menu:Int = 0, GS_Setzen:Int = 1, GS_schiessen:Int = 2, GS_Inp:Int = 3, GS_Dlose:Int = 4
Global GAME_STATE:Int = GS_menu

Global BG:TImage = LoadImage("D/BG.png") 'Background
Global P:TImage = LoadImage("D/P.png")   'Planet
Global AS:TImage = LoadAnimImage("D/as.png", 32, 32, 0, 4) 'Attack Ships
Global DS:TImage = LoadImage("D/ds.png") 'Defense Ships
Global KH:TImage = LoadAnimImage("D/kh.png", 32, 32, 0, 2) 'KreuzHaken
Global S:TImage = LoadAnimImage("D/S.png", 32, 32, 0, 2) 'Schüsse
Global LP:TImage = LoadImage("D/lp.png") 'LifePoint
Global SH:TImage = LoadAnimImage("D/S6x32.png", 32, 32, 0, 6) 'Schildeffekt
Global EX:TImage = LoadAnimImage("D/E7x64.png", 64, 64, 0, 7) 'Explosionseffekt

Global S_s:TSound[] = [LoadSound("D\so1.ogg"), LoadSound("D\so2.ogg")]
Global SH_s:TSound = LoadSound("D\si.ogg")
Global EX_s:TSound = LoadSound("D\ex.ogg")
Global H_s:TSound = LoadSound("D\h.ogg")  '* Treffer
Global Volume:Float = 0.25

Global Inpnr:Int, LevelNr:Int, AS_EP:Int, AS_Hit:Int, AS_MatchPoint:Int, LevelHigh:Int, TxtAlpha:Float, SoundOn:Int = 1
Global DS_X:Float, DS_FT:TNTimer = TNTimer.Create(250) , DS_AllShots:Int, DS_HitShots:Int, DS_LP:Int, DS_MatchPoint:Int
Global LvlGrid:Int[16, 24]
Global P1_Name:String = "Spieler 1"
Global P2_Name:String = "Spieler 2"

If FileType("D/S") Then
	Local file:TStream = ReadFile("D/S")
	P1_Name = file.ReadLine()
	P2_Name = file.ReadLine()
	SoundOn = file.ReadInt()
	file.Close()
EndIf

OnEnd(Save) '* Ein kleines bisschen Benutzerfreundlich sein :)
TShip_Class.Create()

SetClsColor(0, 0, 0)
SetBlend(ALPHABLEND)

'* Standard-Hauptschleife
Repeat
	Cls
	
	ms = MilliSecs()
	mx = MouseX()
	my = MouseY()
	mh1 = MouseHit(1)
	mh2 = MouseHit(2)
	md1 = MouseDown(1)
	md2 = MouseDown(2)
	
	'* Standard-Spielsteuerung
	Select GAME_STATE
		Case GS_menu
			Run_menu()
		Case GS_Inp
			Run_Inp()
		Case GS_Setzen
			Run_setzen()
		Case GS_schiessen
			Run_schiessen()
		Case GS_Dlose
			Run_Dlose()
	End Select
	
	Flip(0)
	Frametimer.Wait()
	'* Kann ja sein, das man aus versehen drauf drückt (oder der Gegner am verlieren ist):
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then If Confirm("Wirklich beenden?", 1) Then End
Forever
End

Function Save()
	Local file:TStream = WriteFile("D/S") '* Dateiendungen werden überbewertet
	file.WriteLine(P1_Name)
	file.WriteLine(P2_Name)
	file.WriteInt(SoundOn)
	file.Close()
End Function


Function Run_menu()
	SD()
	DrawImage(BG, gfx_w2, gfx_h2)
	DrawImage(P, gfx_w2, gfx_h * 1.1)
	SetColor(92, 255, 92)
	'* Kleine Grafikspielerei für das Menü:
	SetAlpha(Abs(Cos((ms Mod 3600) / 20.0))) ; DrawTextMid("Willkommen zu Earth Invaders!", gfx_w2, 32)
	SetAlpha(Abs(Sin((ms Mod 3600) / 20.0))) ; DrawTextMid("ein Spiel für 2 Personen", gfx_w2, 64) ;SetAlpha(1)
	
	SetColor(255, 0, 0)
	If Button("Kämpfe um den Mars", gfx_w2, gfx_h * 0.3) Then
		AS_MatchPoint = 0
		DS_MatchPoint = 0
		LevelHigh = 0
		Start_Game()
	EndIf
	
	SetColor(255, 255, 0)
	If Button("Angreifer: " + P1_Name, gfx_w2, gfx_h * 0.45) Then GAME_STATE = GS_Inp ; Inpnr = 1
	SetScale(0.5, 0.5) If Button("Tauschen", gfx_w2, gfx_h * 0.50, 64, 16) Then NameSwitch()
	SetScale(1, 1) If Button("Verteidiger: " + P2_Name, gfx_w2, gfx_h * 0.55) Then GAME_STATE = GS_Inp ; Inpnr = 2
	
	SD(200)
	If Button("Soundeffekte: " + AnAus(SoundOn), gfx_w2, gfx_h * 0.65) Then SoundOn:~1 ; SetChannelVolume(PlaySound(S_s[0]), Volume)
	If Button("ENDE", gfx_w2, gfx_h * 0.75) Then End
	Tspark.Upate()
End Function

Function Run_setzen()
	Global SelectedShip:Int = 1, ShipPlaced:Int

	SD(255, -1)
	DrawImage(BG, gfx_w2, gfx_h2)
	SD(40) ; DrawGrid()
	If mouseInRect(0, 0, gfx_w, gfx_h - 32) Then SD(192) ;DrawMidRect(MinMax(mx / 32, 0, 15) * 32 + 16, MinMax(my / 32, 0, 23) * 32 + 16, 32, 32)
	
	If TxtAlpha > 0 Then
		SetColor(255, 255, 0) ; SetAlpha(TxtAlpha)
		DrawTextMid("Level: " + LevelNr, gfx_w2, gfx_h * 0.2)
		DrawTextMid(P1_Name + " ist dran", gfx_w2, gfx_h * 0.3)
		TxtAlpha:-0.005
		SetAlpha(1)
	EndIf
	
	SD()
	DrawRect(0, gfx_h - 32, gfx_w, 32)
	SetColor(102, 166, 230)
	'** Kreuz:
	If SelectedShip = 0 Then
		DrawRect(32, gfx_h - 32, 32, 32)
	Else
		DrawRect(32 * (2 + SelectedShip), gfx_h - 32, 32, 32)
	EndIf
	Select ButtonIMG(KH, 0, 16 + 32, gfx_h - 16)
		Case 1; SelectedShip = 0
		Case 2
			SD(192) ;DrawRect(32 * 6, gfx_h - 32 * 6, 128, 64)
			SD(0, 0.6) ;DrawTextMid("Löschen", gfx_w2, gfx_h - 32 * 5)
	End Select
	
	'** Schiffe:
	For Local i:Int = 0 Until 4
	If TShip_Class.Classes[i].LVL <= LevelNr Then
		Select ButtonIMG(AS, i, 16 + 32 * (3 + i), gfx_h - 16)
			Case 1;SelectedShip = TShip_Class.Classes[i].Nr
			Case 2 '* Hover-Overlay:
				SD(192) ;DrawRect(32 * 6, gfx_h - 32 * 6, 128, 64)
				SD() ; DrawImage(AS, gfx_w2 - 32, gfx_h - 32 * 5, TShip_Class.Classes[i].Nr - 1)
				Select TShip_Class.Classes[i].Nr '* Triebwerksspur
					Case 1, 3
					Tspark.Create(gfx_w2 - 32, gfx_h - 32 * 5 - 15, Rnd(45, 135), 0.5, 255, 0, 0)
					Case 4
					Tspark.Create(gfx_w2 - 32 + 6, gfx_h - 32 * 5 - 10, Rnd(45, 135), 0.5, 255, 0, 0)
					Tspark.Create(gfx_w2 - 32 - 6, gfx_h - 32 * 5 - 10, Rnd(45, 135), 0.5, 255, 0, 0)
				End Select
				'If TShip_Class.Classes[i].Nr <> 2 Then Tspark.Create(gfx_w2 - 32, gfx_h - 32 * 5 - 15, Rnd(45, 135), 0.5, 255, 0, 0)
				SD(0, 0.5) ;DrawTextMid(TShip_Class.Classes[i].name, gfx_w2, gfx_h - 32 * 5.65)
				SD(, .4)
				DrawLP(TShip_Class.Classes[i].HP, gfx_w2 + 16, gfx_h - 32 * 4.6)
				DrawLP(TShip_Class.Classes[i].SP, gfx_w2 + 16, gfx_h - 32 * 4.2, 1)
				SD(0, 0.5) ;DrawTextMid(TShip_Class.Classes[i].EP + " EP", gfx_w2 + 16, gfx_h - 32 * 4.3)
		End Select
	EndIf
	Next
	
	'** Ins Gitter ein- und austragen:
	If md1 And mouseInRect(0, 0, gfx_w, gfx_h - 32) Then
		Local GW:Int = LvlGrid[MinMax(mx / 32, 0, 15), MinMax(my / 32, 0, 23)]
		If SelectedShip = 0 And GW <> 0 Then
			AS_EP:+TShip_Class.Classes[GW - 1].EP
			ShipPlaced:-1
			LvlGrid[MinMax(mx / 32, 0, 15), MinMax(my / 32, 0, 23)] = 0
		ElseIf SelectedShip > 0 And GW = 0 Then
			If AS_EP >= TShip_Class.Classes[SelectedShip - 1].EP Then
				AS_EP:-TShip_Class.Classes[SelectedShip - 1].EP
				ShipPlaced:+1
				LvlGrid[MinMax(mx / 32, 0, 15), MinMax(my / 32, 0, 23)] = SelectedShip
				'** Effekte die man hat, sollte man nutzen. Exessiv!
				For Local i:Int = 0 To 40; Tspark.Create(MinMax(mx / 32, 0, 15) * 32 + 16, MinMax(my / 32, 0, 23) * 32 + 16, Rand(0, 360), 3.5, Rand(128, 200), Rand(128, 200), Rand(128, 200)) ;Next
			EndIf
		EndIf
	EndIf
	
	'** Häckchen:
	Select ButtonIMG(KH, 1, 16 + 32 * 15, gfx_h - 16)
		Case 1
			If ShipPlaced > 0 Then
				SelectedShip = 1
				ShipPlaced = 0
				GAME_STATE = GS_schiessen
				DS_X = gfx_w2
				TxtAlpha = 1
				Tspark.list.Clear()
				TShip.GridToList()
			EndIf
		Case 2
			SD(192) ;DrawRect(32 * 6, gfx_h - 32 * 6, 128, 64)
			If ShipPlaced > 0 Then
				SD(0, 0.6) ;DrawTextMid("Level fertig!", gfx_w2, gfx_h - 32 * 5)
			Else
				SD(0, 0.5) ;DrawTextMid("min. 1 Schiff nötig!", gfx_w2, gfx_h - 32 * 5)
			EndIf
	End Select
	
	SD() ;SetColor(255, 128, 0)
	DrawText("EP: " + AS_EP, 320, gfx_h - 32)
	Tspark.Upate()
End Function

Function Run_schiessen()
	SD()
	DrawImage(BG, gfx_w2, gfx_h2)
	DrawImage(P, gfx_w2, gfx_h * 1.1)
	
	If TxtAlpha > 0 Then
		SetColor(255, 255, 0) ; SetAlpha(TxtAlpha)
		DrawTextMid("Level: " + LevelNr, gfx_w2, gfx_h * 0.2)
		DrawTextMid(P2_Name + " ist dran", gfx_w2, gfx_h * 0.3)
		TxtAlpha:-0.005
		SetAlpha(1)
	EndIf
	
	Tspark.Upate()
	TShip.Update()
	TShot.Update()
	TShield.Upate()
	TExp.Upate()
	
	If GAME_STATE = GS_Dlose Then
		If LevelHigh = LevelNr Then
			LevelHigh = 0
		ElseIf LevelHigh < LevelNr Then
			AS_MatchPoint:+1 ;LevelHigh = LevelNr
		EndIf
	EndIf
	
	SD() ;DrawLP(DS_LP, gfx_w2, gfx_h - 6)
	SD() ;DrawImage(DS, DS_X, gfx_h - 64)
	If KeyDown(KEY_LEFT) Then DS_X:-2.5 ; Tspark.Create(DS_X + 32, gfx_h - 64, Rnd(-45, 45), .7, 255, 255, 255)
	If KeyDown(KEY_RIGHT) Then DS_X:+2.5 Tspark.Create(DS_X - 32, gfx_h - 64, Rnd(135, 225), .7, 255, 255, 255)
	DS_X = MinMax(DS_X, 0, gfx_w)
	
	If KeyDown(KEY_UP) And DS_FT.Check() Then
		DS_AllShots:+1
		TShot.Create(DS_X, gfx_h - 64, 90, 1)
	ElseIf KeyDown(KEY_LCONTROL) Or KeyDown(KEY_RALT) And DS_FT.Check() Then
		DS_AllShots:+1
		TShot.Create(DS_X, gfx_h - 64, 95, 1)
	ElseIf KeyDown(KEY_LALT) Or KeyDown(KEY_RCONTROL) And DS_FT.Check() Then
		DS_AllShots:+1
		TShot.Create(DS_X, gfx_h - 64, 85, 1)
	EndIf
	
	If KeyHit(KEY_S) Then SoundOn:~1
	
	If TShip.list.IsEmpty() Then
		LevelNr:+1
		DS_LP:+1
		
		AS_EP = MinMax(Float(DS_AllShots) / Float(DS_HitShots), 0, 3) * (AS_Hit * 10 + LevelNr * 10)
		
		AS_Hit = 0
		DS_AllShots = 0
		DS_HitShots = 0
		Tspark.list.Clear()
		TShot.list.Clear()
		TShield.list.Clear()
		TExp.list.Clear()
		TxtAlpha = 1
		GAME_STATE = GS_Setzen
	EndIf
		
End Function

Function Run_Dlose()
	SD(, -1) ; DrawImage(BG, gfx_w2, gfx_h2)
	SD(,, -45) ; DrawImage(P, gfx_w2, -gfx_h * 0.2)
	SD() ;SetColor(255, 0, 0)
	DrawTextMid(P2_Name + " Verlor in Level " + LevelNr + "!", gfx_w2, gfx_h * 0.3)
	SetColor(255, 255, 0)
	DrawTextMid("Stand:", gfx_w2, gfx_h * 0.4)
	DrawTextMid(P1_Name, gfx_w *.33, gfx_h * 0.45) ;DrawTextMid(P2_Name, gfx_w *.66, gfx_h * 0.45)
	DrawTextMid(AS_MatchPoint, gfx_w *.33, gfx_h * 0.5) ;DrawTextMid(DS_MatchPoint, gfx_w *.66, gfx_h * 0.5)
	If Button("Plätze tauschen und weiter spielen!", gfx_w2, gfx_h * 0.6, 420) Then
		NameSwitch()
		Start_Game()
	End If
	SD(200)
	If Button("Zum Menu", gfx_w2, gfx_h * 0.8) Then GAME_STATE = GS_menu ;Tspark.list.Clear()
	Tspark.Upate()
End Function

Function NameSwitch()
	Local n:String = P1_Name, p:Int = AS_MatchPoint
	P1_Name = P2_Name
	AS_MatchPoint = DS_MatchPoint
	P2_Name = n
	DS_MatchPoint = P
End Function

Function Start_Game()
	Tspark.list.Clear()
	TShip.list.Clear()
	TShot.list.Clear()
	TShield.list.Clear()
	LevelNr = 1
	AS_EP = 10
	DS_LP = 3
	TxtAlpha = 1
	GAME_STATE = GS_Setzen
	FlushMouse()
End Function

Type TShip_Class
	Global Classes:TShip_Class[4]
	Field name:String, Nr:Int
	Field HP:Int, SP:Int '* Hitpoints, Shieldpoints
	Field ST:Int '* Schiesst alle ST ms
	Field SS:Byte '* Verschiesst SpreadShot
	Field EP:Int, LVL:Int '* AS_EP, Verfügbar ab Level
	Field A:Byte '* Aktiv - sobald sichtbar
		
	Function Create()
		Classes[0] = New TShip_Class
		Classes[0].name = "Aufklärer"
		Classes[0].Nr = 1
		Classes[0].HP = 1
		Classes[0].SP = 1
		Classes[0].ST = 5000
		Classes[0].EP = 2
		Classes[0].LVL = 1
		
		Classes[1] = New TShip_Class
		Classes[1].name = "Asteroid"
		Classes[1].Nr = 2
		Classes[1].HP = 4
		Classes[1].SP = 0
		Classes[1].ST = -1
		Classes[1].EP = 5
		Classes[1].LVL = 3
		
		Classes[2] = New TShip_Class
		Classes[2].name = "Jäger"
		Classes[2].Nr = 3
		Classes[2].HP = 2
		Classes[2].SP = 3
		Classes[2].ST = 3000
		Classes[2].EP = 8
		Classes[2].LVL = 4
		
		Classes[3] = New TShip_Class
		Classes[3].name = "Kreuzer"
		Classes[3].Nr = 4
		Classes[3].HP = 5
		Classes[3].SP = 5
		Classes[3].ST = 5000
		Classes[3].SS = 1
		Classes[3].EP = 15
		Classes[3].LVL = 6
	End Function
End Type

Type TShip Extends TShip_Class
	Field x:Float, y:Float, FT:TNTimer '*Firetimer
	Field SP_max:Int, SP_reg:Float, lpa:Float '* Schildmaximum, Regeneration, LebensPunkteAlpha
	Global list:TList = CreateList()
	
	Method del()
		TExp.Create(Self.x, Self.y)
		list.Remove(Self)
	End Method
	
	Method Draw()
		SD() ;DrawImage(AS, Self.x, Self.y, Self.Nr - 1)
		SD(, .4) ;SetAlpha(Self.lpa)
		DrawLP(Self.HP, Self.x, Self.y)
		DrawLP(Self.SP, Self.x, Self.y, 1)
		SetAlpha(1)
		If Self.SP_reg <> 0 Then SetScale(1, 1) ; DrawRect(Self.x - 8, Self.y - 18, 16 * Self.SP_reg, 4)
	End Method
	
	Method FireShot()
		'Self.FT = ms + Self.ST
		TShot.Create(Self.x, Self.y, 270, 0)
		If Self.SS Then
			TShot.Create(Self.x, Self.y, 267, 0)
			TShot.Create(Self.x, Self.y, 273, 0)
		End If	
	End Method
	
	Function Update()
		For Local S:TShip = EachIn TShip.list
			S.y:+0.4
			If S.A = 0 Then If S.y > 8 Then S.A = 1 ;If S.FT <> Null Then S.FT.SetTo(Rand(S.FT.D / 10.0, S.FT.D / 2.0))

			S.Draw()

			If S.A = 1 Then
				If S.SP < S.SP_max Then
					S.SP_reg:+0.004	'* Schildaufladung per Frame
				Else
					If S.lpa > 0 Then S.lpa:-0.008 '* Anzeige von HP und Schild langsam ausblenden
				EndIf
				If S.SP_reg >= 1 Then S.SP_reg = 0;S.SP:+1
				Select S.Nr	'* Triebwerksspur
					Case 1, 3
					Tspark.Create(S.x, S.y - 15, Rnd(45, 135), 0.5, 255, 0, 0)
					Case 4
					Tspark.Create(S.x + 6, S.y - 10, Rnd(45, 135), 0.5, 255, 0, 0)
					Tspark.Create(S.x - 6, S.y - 10, Rnd(45, 135), 0.5, 255, 0, 0)
				End Select
				If S.FT <> Null Then If S.FT.Check() Then S.FireShot()
			EndIf
			
			'** Verteidiger verliert!
			If S.y > (gfx_h - 64) Then GAME_STATE = GS_Dlose
			If S.HP = 0 Then S.del()
		Next
	End Function
	
	Function GridToList()
		Local LeerZeile:Int = -1
		For Local y:Int = 23 To 0 Step - 1
			For Local x:Int = 15 To 0 Step - 1
				If LvlGrid[x, y] > 0 Then
					'Print(LvlGrid[x, y])
					'Print((16 + x * 32) + ", " + (16 + y * 32) + " Ship")
					rem
						Fair Game (TM)
						Die	Zeile wird bestimmt, in der das erste Schiff steht
						ab da werden die Schiffe positioniert - so muss man nicht
						ewig warten, bis es los geht.
						Es sei denn, der Angreifer positioniert ein Scout vorne 
						und die Armada ganz hinten... aber wer macht sowas schon?
					endrem
					If LeerZeile = -1 Then LeerZeile = 23 - y
					TShip.CreateFromClassNr(LvlGrid[x, y] - 1, 16 + x * 32, 16 + (LeerZeile + y) * 32)
					LvlGrid[x, y] = 0
				EndIf
			Next
			'If LeerZeile = True Then TShip.list.AddLast("X")
		Next
		TShip.list.Reverse()
	End Function
	
	Function CreateFromClassNr(_classnr:Int, _x:Int, _y:Int)
		'Print("CreateFromClassNr " + _classnr + "@ " + _x + ", " + _y)
		Local S:TShip = New TShip
		TShip.list.AddLast(S)
		S.x = _x; S.y = _y - gfx_h	'* Eine Spielfeld länge nach oben versetzen... sollte klar sein warum.
		S.name = TShip_Class.Classes[_classnr].name
		S.Nr = TShip_Class.Classes[_classnr].Nr
		S.HP = TShip_Class.Classes[_classnr].HP
		S.SP = TShip_Class.Classes[_classnr].SP ;S.SP_max = S.SP
		'S.ST = TShip_Class.Classes[_classnr].ST
		Local T:Int = TShip_Class.Classes[_classnr].ST
		If T > 0 Then S.FT = TNTimer.Create(T)
		S.SS = TShip_Class.Classes[_classnr].SS
	End Function
End Type

Type TShot
	Field x:Float, y:Float, w:Int, f:Int
	Global list:TList = CreateList()
	
	Method del()
		list.Remove(Self)
	End Method
	
	Method Draw()
		SD() ; SetRotation(90 - w)
		DrawImage(S, Self.x, Self.y, Self.f)
	End Method
	
	Method Move()
		Self.x:+Cos(Self.w) * (Self.f + 1) * 2
		Self.y:-Sin(Self.w) * (Self.f + 1) * 2
		If Self.y > gfx_h Or Self.y < 0 Then Self.del()
	End Method
	
	Function Update()
		For Local S:TShot = EachIn TShot.list
			S.Draw()
			S.Move()
			If S.f = 1 Then
				Tspark.Create(S.x, S.y, Rand(180, 360), 0.6, 120, 120, Rand(200, 255))
				For Local Ship:TShip = EachIn TShip.list
					If Distanz(Ship.x, Ship.y, S.x, S.y) < 18 Then
						DS_HitShots:+1
						Ship.lpa = 1
						If Ship.SP > 0 Then
							rem
								Schild-treffer-effekt
								Alternativer Winkel:(ATan2(Ship.y - S.y, Ship.x - S.x) + 360 + 90) Mod 360
								Treffer-Energie nach Hinten ablaufen lassen (+0°)
								oder Schild-Energie	vorne ausgleichen (+180°) ?
							endrem
							TShield.Create(Ship, 90 - S.w)
							Ship.SP:-1
						Else
							Ship.HP:-1
							If Ship.HP > 0 And SoundOn Then SetChannelVolume(PlaySound(H_s), Volume)
						EndIf
						S.del() ;Exit '* Keine Mehrfachkollision des Schusses -> raus aus der Schleife
					EndIf
				Next
			Else
				Tspark.Create(S.x, S.y, Rand(180, 0), 0.6, Rand(64, 200), 128, 0)
				If Distanz(DS_X, gfx_h - 64, S.x, S.y) < 32 Then
					'* Treffer auf Verteidiger-Schiff
					S.del()
					DS_LP:-1
					AS_Hit:+1
					TExp.Create(DS_X, gfx_h - 64)
					If DS_LP <= 0 Then
						GAME_STATE = GS_Dlose
					ElseIf DS_LP > 0 And SoundOn Then
						SetChannelVolume(PlaySound(H_s), Volume)
					EndIf
				EndIf
			EndIf
		Next
	End Function
	
	Function Create(_x:Float, _y:Float, _w:Int, _f:Int)
		If SoundOn Then SetChannelVolume(PlaySound(S_s[_f]), Volume)
		Local S:TShot = New TShot
		TShot.list.AddLast(S)
		S.x = _x
		S.y = _y
		S.w = _w
		S.f = _f
	End Function
	
End Type

Type TShield
	Field T:TNTimer, F:Int, w:Int, typ:Int
	Field S:TShip
	Global list:TList = CreateList()
	
	Method del()
		list.Remove(Self)
	End Method
	
	Function Create(_ship:TShip, _w:Int = 0, _t:Int = 0)
		If SoundOn Then SetChannelVolume(PlaySound(SH_s), Volume)
		Local S:TShield = New TShield
		TShield.list.AddLast(S)
		S.T = TNTimer.Create(50)
		S.S = _ship
		S.w = _w
	End Function
	
	Function Upate()
		For Local S:TShield = EachIn TShield.list
			If S.S = Null Then S.del;Continue
			If S.T.Check() Then
				S.F:+1
				If S.F > 5 Then S.del;Continue
			EndIf
			SD(,, S.w) ;SetBlend(LightBlend)
			For Local i:Int = 0 To 5 '* Vergleiche den Effekt ohne Mehrfaches Zeichnen!
				DrawImage(SH, S.S.x, S.S.y, S.F)
			Next
			SetBlend(AlphaBlend)
		Next
	End Function
	
End Type

Type TExp
	Field T:TNTimer, F:Int
	Field x:Int, y:Int
	Global list:TList = CreateList()
	
	Method del()
		list.Remove(Self)
	End Method
	
	Function Create(_x:Int, _y:Int)
		If SoundOn Then SetChannelVolume(PlaySound(EX_s), Volume)
		For Local i:Int = 0 To 25; Tspark.Create(_x, _y, Rand(0, 360), 3.5, Rand(128, 200), Rand(128, 200), Rand(128, 200)) ; Next
		Local E:TExp = New TExp
		TExp.list.AddLast(E)
		E.T = TNTimer.Create(Rand(30, 60))
		E.x = _x
		E.y = _y
	End Function
	
	Function Upate()
		For Local E:TExp = EachIn TExp.list
			If E.T.Check() Then
				E.F:+1
				If E.F > 6 Then E.del;Continue
			EndIf
			SD() ;SetBlend(LightBlend)
			For Local i:Int = 0 To 3 '* Vergleiche den Effekt ohne Mehrfaches Zeichnen!
				DrawImage(EX, E.x, E.y, E.F)
			Next
			SetBlend(AlphaBlend)
		Next
	End Function
End Type

Type Tspark
	Field x:Float, y:Float, w:Float, s:Float, a:Float, r:Int, g:Int, b:Int
	Global list:TList = CreateList()
	
	Method del()
		list.Remove(Self)
	End Method
	
	Function Create(_x:Int, _y:Int, _w:Float, _s:Float, _r:Int, _g:Int, _b:Int)
		Local s:Tspark = New Tspark
		Tspark.list.AddLast(s)
		s.x = _x
		s.y = _y
		S.w = _w '(_w + Rnd(-45.0, 45.0) + 360.0) Mod 360.0
		S.S = _s
		s.a = 1
		s.r = _r
		s.g = _g
		s.b = _b
	End Function
	
	Function Upate()
		For Local s:Tspark = EachIn Tspark.list
			s.x:+Cos(s.w) * s.s
			s.y:-Sin(s.w) * s.s
			s.a:-0.05
			If s.a <= 0 Then s.del ; Continue
			SD() ;SetAlpha(s.a) SetColor(s.r, s.g, s.b)
			DrawOval(s.x - 3, s.y - 3, 6, 6)
			SetAlpha(1)
		Next
	End Function
	
End Type

Type TNTimer
	Field Z:Int, D:Int '* Zeit & Dauer
	
	Method Check:Int()
		If Self.Z + Self.D < ms Then
			Self.Reset()
			Return True
		Else
			Return False
		End If
	End Method
	
	Method SetTo(_zeit:Int)
		Self.Z = ms - Self.D + _zeit
	End Method
	
	Method Reset()
		Self.Z = ms
	End Method
	
	Function Create:TNTimer(_dauer:Int, _StartType:Int = False)
		Local t:TNTimer = New TNTimer
		'** Timer ausgelaufen starten (beim ersten Check 'schlägt' er)
		If _StartType = True Then
			t.Z = ms
		Else
			t.Z = 0
		EndIf
		t.D = _dauer
		Return t
	End Function
	
End Type

Function MinMax:Float(_value:Float, _Min:Float, _Max:Float)
	If _value < _Min Then
		Return _Min
	ElseIf _value > _Max Then
		Return _max
	Else
		Return _value
	EndIf
End Function

Function Distanz:Float(sx:Float, sy:Float, zx:Float, zy:Float)
	Return Sqr(((zx - sx) ^ 2) + ((zy - sy) ^ 2))
End Function

Function Run_Inp()
	Global txt:String, free:Int = 1, fkh:Int = 1, bt:TNTimer = TNTimer.Create(500), b:Int
	'*** Grauenhafter Hack um die Namen fest zu legen.. kurz genug isses...
	If Inpnr = 1 And free = 1 Then txt = P1_Name; free = 0 FlushKeys
	If Inpnr = 2 And free = 1 Then txt = P2_Name; free = 0 FlushKeys
	If KeyHit(KEY_ENTER) Then
		If Inpnr = 1 Then P1_Name = Trim(txt[..10]) ; If P1_Name = "" Then P1_Name = "Spieler 1"
		If Inpnr = 2 Then P2_Name = Trim(txt[..10]) ; If P2_Name = "" Then P2_Name = "Spieler 2"
		GAME_STATE = GS_menu ;free = 1;fkh = 1;Return
	EndIf
	If KeyHit(KEY_BACKSPACE) Then
		txt = txt[..txt.length - 1] '** Slices - schöne Sache!
		If fkh = 1 Then txt = "";fkh = 0  '* First Keyhit: Alles Löschen
	ElseIf KeyHit(KEY_LEFT) Then
		txt = ""
	Else
		Local c:Int = GetChar()
		If c > 31 Then txt:+Chr(c) ;fkh = 0
	EndIf
	SetColor(255, 255, 0)
	If bt.Check() Then b:~1
	If b Then
		DrawText(">" + txt + "<", 32, gfx_h2)
	Else
		DrawText(">" + txt, 32, gfx_h2)
	EndIf
End Function

Function DrawLP(_count:Int, _X:Int, _Y:Int, _type:Int = 0)
	Local s:Float; GetScale(s, s)
	Select _type
		Case 0; SetColor(240, 64, 64)
		Case 1; SetColor(102, 166, 230)
	End Select
	For Local i:Int = 1 To _count
		DrawImage(LP, _X - (((_count - 1) / 2.0) * (20 * S)) + (i - 1) * (20 * S), _Y - 18 - _type * 3)
	Next
End Function


Function Button:Int(_txt:String, _x:Int, _y:Int, _w:Int = 320, _h:Int = 32)
	Local re:Int = 0, s:Float
	GetScale(s, s) ;SetScale(1, 1)
	If mouseInRect(_x - _w / 2, _y - _h / 2, _w, _h)
		'Highlight
		Tspark.Create((_x + _w / 2), _y, Rnd(-45, 45), 3, Rand(0, 255), Rand(0, 255), Rand(0, 255))
		Tspark.Create((_x - _w / 2), _y, Rnd(135, 225), 3, Rand(0, 255), Rand(0, 255), Rand(0, 255))
        DrawMidRect(_x, _y, _w - 2, _h - 2)
		DrawMidRect(_x, _y, _w - 8, _h - 8)
		DrawMidRect(_x, _y, _w - 8, _h - 8)
		If mh1 = True Then re = 1
	EndIf
	DrawMidRect(_x, _y, _w, _h)
	SetScale(s, s)
	DrawTextMid(_txt, _x, _y)
	Return re
End Function

Function ButtonIMG:Int(img:TImage, _frame:Int = 0, _x:Int, _y:Int)
	Local re:Int = 0, _w:Int = img.width, _h:Int = img.height
	If mouseInRect(_x - _w / 2, _y - _h / 2, _w, _h)
		re = 2
		SetColor(255, 128, 0)
		DrawRect(_x - _w / 2, _y - _h / 2, _w, _h)
		If mh1 = True Then re = 1
	EndIf
	'DrawMidRect(_x, _y, _w, _h)
	SD()
	DrawImage(img, _x, _y, _frame)
	Return re
End Function

Function AnAus:String(_value:Int)
	If _value >= 1 Then
		Return "An"
	Else
		Return "Aus"
	End If
End Function

'* Oft wiederholte Funktionen sind für den BCC gewrappt:
Function SD(c:Int = 255, s:Float = 1.0, r:Float = 0)
	SetColor(c, c, c) ;SetScale(S, S) ;SetRotation(r)
End Function

Function DrawGrid(w:Int = 32, h:Int = 32)
	Local C:Int; GetColor(C, C, C)
	For Local x:Int = 0 Until 16
		For Local y:Int = 0 Until 24
			SD(C)
			DrawLine(0, y * h, gfx_w, y * h)
			DrawLine(x * w, 0, x * w, gfx_h)
			If LvlGrid[x, y] > 0 Then
				SD() ;DrawImage(AS, 16 + x * 32, 16 + y * 32, LvlGrid[x, y] - 1)
			EndIf
		Next
	Next
End Function

Function DrawTextMid(txt:String, X:Float, Y:Float)
	Local scale_X:Float, scale_Y:Float
	GetScale(scale_X, scale_Y)
	DrawText(txt, Int(X - (Float(TextWidth(txt)) * scale_X / 2.0)), Int(Y - (Float(TextHeight(txt)) * scale_Y / 2.0)))
End Function

Function mouseInRect:Int(x:Int, y:Int, w:Int, h:Int)
	If mx <= x Then Return 0
	If my <= y Then Return 0
	If mx >= x + w Then Return 0
	If my >= y + h Then Return 0
	Return 1
End Function

Function DrawMidRect(fx:Float, fy:Float, fw:Float, fh:Float = -1)
	fw = fw / 2;fh = fh / 2
	DrawLine(fx - fw, fy - fh, fx + fw, fy - fh)
	DrawLine(fx + fw, fy - fh, fx + fw, fy + fh)
	DrawLine(fx + fw, fy + fh, fx - fw, fy + fh)
	DrawLine(fx - fw, fy + fh, fx - fw, fy - fh)
End Function